#import "Buttons.h"
#import "Table.h"
#import "iDeckAppDelegate.h"
#import "Hand.h"

@implementation Buttons

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
	printf("User Pressed Button %d\n", buttonIndex);	
	printf("Text Field 1: %s\n", [[[alertView textFieldAtIndex:0] text] cStringUsingEncoding:1]);
	if (buttonIndex == 0) {


		NSLog(@"cancelled");

	} else {

		UITextField *tf = [alertView textFieldAtIndex:0];
		iDeckAppDelegate * parent = (iDeckAppDelegate*) [[UIApplication sharedApplication] delegate];
		[[parent table] send:tf.text];


	}
	[alertView release];
}

- (void) presentSheet {
	UIAlertView *alert = [[UIAlertView alloc] 
		initWithTitle: @"Text Message" 
		message:@"Type your message"
		delegate:self
		cancelButtonTitle:@"Cancel"
		otherButtonTitles:@"OK", nil];
	[alert addTextFieldWithValue:@"" label:@"Enter Message"];

	// Name field
	UITextField *tf = [alert textFieldAtIndex:0];

	//	UITextField * tf = [[UITextField alloc] init];
	tf.clearButtonMode = UITextFieldViewModeWhileEditing;
	tf.keyboardType = UIKeyboardTypeAlphabet;
	tf.keyboardAppearance = UIKeyboardAppearanceAlert;
	tf.autocapitalizationType = UITextAutocapitalizationTypeWords;
	tf.autocorrectionType = UITextAutocorrectionTypeNo;
	//		[alert addSubview:tf];
	[alert show];
}

- (void) touchesBegan:(NSSet*)touches withEvent:(UIEvent*)event {

	iDeckAppDelegate * parent = (iDeckAppDelegate*)[[UIApplication sharedApplication] delegate];

	switch (eventType) {
		case DEAL:
			[[parent table] deal];
			NSLog(@"deal!\n");
			break;
		case SHUFFLE:
			[[parent table] shuffle];
			NSLog(@"shuffle\n");
			break;			
		case LEAVE:
			[[parent table] deinitializeTable];
			[[[parent table] view] removeFromSuperview];
			break;
		case MESSAGE:
			[self presentSheet];	
			break;
		case REFRESH:
			//			[(Table*)self.superview queryAndViewTable];
			[[parent table] queryAndViewTable];

			break;
		case VIEWHAND:
			if (parent->table->viewTable) {
				[[parent table] viewHand];
				[[[parent table] view] addSubview:(UIView*)[parent hand]];
				[[[parent table] view] bringSubviewToFront:[parent hand]];
				[[parent hand] showHand];
			} else {
				[[parent table] viewTable];
				[[parent hand] removeFromSuperview];
			}
			NSLog(@"view hand\n");
			break;
	}
}
- (void) touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {}
-(void) setEvent:(int)event {
	eventType = event;	
}
@end
