#import "Cards.h"
#import "iDeckAppDelegate.h"
#import "Table.h"
#import "Player.h"

@implementation Card

/* setters */
- (void) setDirty : (bool) b { dirty = b; }
- (void) setState : (int) s { state = s; }
- (void) setOwner : (int) s { user_id = s; }
- (void) setCard : (int) s { card_id = s; }
- (void) setFace : (bool) f { face = f; }
- (void) setSuit : (NSString*) s { suit = s; [suit retain]; }
- (void) setNum : (NSString*) n { number = n; [number retain]; }
- (void) setLoc: (CGPoint) pos {
	CGRect frame = [self frame];
	frame.origin.x = pos.x;
	frame.origin.y = pos.y;
	[self setFrame:frame];
}
- (void) setMove:(CGPoint) pos {moveTo = pos;}
- (bool) face {return face;}

- (CGPoint) moveTo { return moveTo; }
- (int) owner { return user_id; }
- (int) card_id { return card_id; }
- (bool) dirty { return dirty; }
- (CGPoint) loc { return self.frame.origin; }

- (Card *) flip {
	if (!face) {
		self.image = [self.animationImages objectAtIndex:FACE_UP];
	} else {
		iDeckAppDelegate * parent = (iDeckAppDelegate*)[[UIApplication sharedApplication] delegate];
		if (parent->user_id == user_id) self.image = [self.animationImages objectAtIndex:FACE_USERS];
		else self.image = [self.animationImages objectAtIndex:FACE_DOWN];

	}
	face = !face;
	dirty = true;
	return self;
}

- (void) touchesBegan:(NSSet*)touches withEvent:(UIEvent*)event {

	iDeckAppDelegate * parent = (iDeckAppDelegate*)[[UIApplication sharedApplication] delegate];

	// deck is user_id 0
	if ((user_id == 0) || parent->dealer || (parent->user_id == user_id)) { 
		/* move to top  */
		[[self superview] bringSubviewToFront:self];

		if([[touches anyObject] tapCount] == 2) {
			if (user_id == 0 && self.frame.origin.x ==0 && self.frame.origin.y == 0) [(Table*)parent->table dealAction];
			else [self flip];
		} else {
			CGPoint pt = [[touches anyObject] locationInView:self];
			startLocation = pt;
			//self.image = [self.animationImages objectAtIndex:MOVING];

		}
	}
}

- (void) touchesMoved:(NSSet*)touches withEvent:(UIEvent*)event {

	iDeckAppDelegate * parent = (iDeckAppDelegate*)[[UIApplication sharedApplication] delegate];
	if (parent->dealer || (parent->user_id == user_id) || (user_id == 0)) {

		if (!changedOwners && !face) {
			self.image = [self.animationImages objectAtIndex:MOVING];
		}


		// Move relative to the original touch point
		CGPoint pt = [[touches anyObject] locationInView:self];
		CGRect frame = [self frame];
		frame.origin.x += pt.x - startLocation.x;
		frame.origin.y += pt.y - startLocation.y;
		[self setFrame:frame];
		dirty = true;

		count++; // USED FOR THROTTLING SO WE DON'T OVERLOAD CPU
		if (count % 3 == 0) {
			//if (true) {
			Player * nearest = NULL;
			float dist = 999999;
			for(unsigned int i=0; i<[[[[parent table] view] subviews] count]; i++) {

				if ([[[[[parent table] view] subviews] objectAtIndex:i] isKindOfClass:[Player class]]) {
					Player * somePlayer = [[[[parent table] view] subviews] objectAtIndex:i];
					CGRect newFrame = [somePlayer frame];
					float d = (newFrame.origin.x - frame.origin.x)*(newFrame.origin.x - frame.origin.x) + (newFrame.origin.y - frame.origin.y)*(newFrame.origin.y - frame.origin.y);
					if (d<dist) {
						dist = d;
						nearest = somePlayer;

					}
				}
			}
			if (dist < 230 && nearest && (user_id != nearest->user_id)) {

				user_id = nearest->user_id;
				NSLog(@"card changed owners");
				parent->table->dealState = false;
				self.image = [self.animationImages objectAtIndex:FACE_DOWN];
				face = false;
				changedOwners = true;
			}
		}
		}
	}

	- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
		changedOwners = false;
		if (face) {
			self.image = [self.animationImages objectAtIndex:FACE_UP];
		} else {
			iDeckAppDelegate * parent = (iDeckAppDelegate*)[[UIApplication sharedApplication] delegate];
			if (parent->user_id == user_id) self.image = [self.animationImages objectAtIndex:FACE_USERS];
			else self.image = [self.animationImages objectAtIndex:FACE_DOWN];

		}
	}

	@end
