//
//  ContactsViewController.m
//  iDeck
//
//  Created by Class Account on 4/3/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ContactsViewController.h"
#import "SearchUsersViewController.h"
#import "DOMTreeNode.h"
#import "iDeckAppDelegate.h"


@implementation ContactsViewController

@synthesize contactsTable;

/*
// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
// Custom initialization
}
return self;
}
 */

- (void) getUsers {

	if (users) [users  release];
	XMLParser *parser = [[XMLParser alloc] init];
	NSMutableString * url = [[NSMutableString alloc] init];

	[url appendFormat:@"http://dan-lynch.com/icards.php?action=list_players"];
	users = [parser parseXMLFile:[NSURL URLWithString:url]];
	//[root dump];
	[users retain];
	[parser release];

	if (rows) [rows release];
	if (keys) [keys release];
	rows = [[NSMutableArray alloc] init];
	keys = [[NSMutableArray alloc] init];
	unsigned int i = 0;
	for(DOMTreeNode *user in objs(users, @"players")) {

		if(is(user, @"player")) {
			NSString * userName = [[NSString alloc] initWithFormat:@"%@",node(user, @"name")];
			NSString * str = [[NSString alloc] initWithString:node(user, @"table_id")];
			[rows addObject:userName];
			[keys addObject:str];
			[userName retain];
			[str retain];
		}
		i++;
	}

}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	self.title = NSLocalizedString(@"Contacts",@"");
	[self getUsers];
	[super viewDidLoad];
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	return 2;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	// add code to get actual numbers of rows
	if (section == 0) {
		return [rows count];
	} else {
		return [rows count];
	}
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {


	static NSString *CellIdentifier = @"Cell";

	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];

	if (cell == nil) {
		cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
	}

	[cell.textLabel setText:[rows objectAtIndex:indexPath.row]];

	return cell;


}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {

	iDeckAppDelegate * parent = (iDeckAppDelegate *) [[UIApplication sharedApplication] delegate];
	// set the table id to the selection
	[parent setTableID:[[keys objectAtIndex:indexPath.row] intValue]];

	/*
	   UITableViewCell *thisCell = [tableView cellForRowAtIndexPath:indexPath];

	   if (thisCell.accessoryType == UITableViewCellAccessoryNone) {
	   thisCell.accessoryType = UITableViewCellAccessoryCheckmark;
	   } else {
	   thisCell.accessoryType = UITableViewCellAccessoryNone;
	   }
	 */

}

/*
   - (UITableViewCellAccessoryType)tableView:(UITableView *)tableView accessoryTypeForRowWithIndexPath:(NSIndexPath *)indexPath {
   return UITableViewCellAccessoryNone;
   }
 */

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {

	if (section == 0) {
		return @"Online";
	} else {
		return @"Offline";
	}

}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
// Return YES for supported orientations
return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
	[super didReceiveMemoryWarning];

	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[contactsTable release];
	[super dealloc];
}

- (void)alertInvitedConfirmation {
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Users Invited" message:@"Selected user(s) have been invited!" delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
	[alert show];
	[alert release];
}

- (void)alertRequestJoinConfirmation {
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Request Sent" message:@"Request to join selected user's table sent!" delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
	[alert show];
	[alert release];
}

- (IBAction)inviteUsers:(id)sender {
	[self alertInvitedConfirmation];
	// invite code
}

/*
   - (IBAction)requestToJoin:(id)sender {
   [self alertRequestJoinConfirmation];
// request join code
}
 */

- (IBAction)pushGameTable:(id)sender {

}

- (IBAction)pushSearchUsers:(id)sender {
	SearchUsersViewController *searchUsersViewController = [[SearchUsersViewController alloc]
		initWithNibName:@"SearchUsersViewController" bundle:[NSBundle mainBundle]];
	[[self navigationController] pushViewController:searchUsersViewController animated:YES];
	[searchUsersViewController release];
}

@end
