@interface DOMTreeNode : NSObject {
	DOMTreeNode		*parent;
	NSMutableArray	*children;
	NSString		*key;
	NSString		*leafvalue;
}
@property (nonatomic, retain) 	DOMTreeNode		*parent;
@property (nonatomic, retain) 	NSMutableArray	*children;
@property (nonatomic, retain) 	NSString		*key;
@property (nonatomic, retain) 	NSString		*leafvalue;

- (BOOL) isLeaf;
- (DOMTreeNode *) objectForKey: (NSString *) aKey;
- (NSString *) leafForKey: (NSString *) aKey;
- (void) dump;
@end

@interface XMLParser : NSObject {
	NSMutableArray		*stack;
	DOMTreeNode			*root;
}

@property (nonatomic, retain)	NSMutableArray *stack;
@property (nonatomic, retain)	DOMTreeNode *root;
- (DOMTreeNode *)parseXMLFile: (NSURL *) url;
@end

#define node(x,y) [[x objectForKey:y] leafvalue]
#define objs(x,k) [[x objectForKey:k] children]
#define is(x,s) [[x key] isEqualToString:s]
#define eq(x,s) [x isEqualToString:s]
#define getName(x) node(x,@"name")
