#import "FindUsersViewController.h"
#import "iDeckAppDelegate.h"
#import "DOMTreeNode.h"
#import "ContactCell.h"


@implementation FindUsersViewController

/*
// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
// Custom initialization
}
return self;
}
 */

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    NSLog(@"user_rotate\n");
    return NO;
}

- (void) getUsers {

	if (users) [users release];
	XMLParser *parser = [[XMLParser alloc] init];
	NSMutableString * url = [[NSMutableString alloc] init];

	[url appendFormat:@"http://dan-lynch.com/icards.php?action=get_players"];
	users = [parser parseXMLFile:[NSURL URLWithString:url]];
	//[root dump];
	[users retain];
	[parser release];

	if (rows) [rows release];
	if (keys) [keys release];
	rows = [[NSMutableArray alloc] init];
	keys = [[NSMutableArray alloc] init];
	unsigned int i = 0;
	for(DOMTreeNode *user in objs(users, @"players")) {

		if(is(user, @"player")) {
			NSString * userName = [[NSString alloc] initWithFormat:@"%@",node(user, @"username")];
			NSString * str = [[NSString alloc] initWithString:node(user, @"table_id")];
			node(user, @"table_id");
			[rows addObject:userName];
			[keys addObject:str];
			[userName retain];
			[str retain];
		}
		i++;
	}

}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.

- (void)viewDidLoad {
	self.title = NSLocalizedString(@"Find Users",@"");
	[self getUsers];
	[super viewDidLoad];
}


- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	// add code to get actual numbers of rows
	return [rows count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {

	static NSString *CellIdentifier = @"Cell";

	ContactCell *cell = (ContactCell*)[tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (cell == nil) {
		cell = [[[ContactCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
	}

	cell.primaryLabel.text = [rows objectAtIndex:indexPath.row];
	cell.myImageView.image = [UIImage imageNamed:@"contact_icon.png"];

	/*UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];

	  if (cell == nil) {
	  cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
	  }

	  [cell.textLabel setText:[rows objectAtIndex:indexPath.row]];*/

	return cell;

}


- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
	return 50;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {

       iDeckAppDelegate * parent = (iDeckAppDelegate *) [[UIApplication sharedApplication] delegate];
       // set the table id to the selection
       [parent setTableID:[[keys objectAtIndex:indexPath.row] intValue]];
       if ([parent table_id] != -1) {
               
               [parent startTimer];
               [[parent window] addSubview:[[parent table] view]];
               [parent initializeTable];
               //[[self navigationController] pushViewController:(UIViewController*)[parent table] animated:YES];
               
       }

}

/*
   - (UITableViewCellAccessoryType)tableView:(UITableView *)tableView accessoryTypeForRowWithIndexPath:(NSIndexPath *)indexPath {
   return UITableViewCellAccessoryNone;
   }
 */

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
	return @"Select a user to join their table";
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
// Return YES for supported orientations
return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
	[super didReceiveMemoryWarning];

	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[super dealloc];
}


// game table view
- (IBAction)pushGameTable:(id)sender{
	iDeckAppDelegate * parent = [[UIApplication sharedApplication] delegate];
	if ([parent table_id] != -1) {

		[parent startTimer];
		[[parent window] addSubview:[[parent table] view]];
		[parent initializeTable];
		//[[self navigationController] pushViewController:(UIViewController*)[parent table] animated:YES];

	}

}

@end
