#import "HomeViewController.h"
#import "TablesViewController.h"
#import "FindUsersViewController.h"
#import "iDeckAppDelegate.h"

@implementation HomeViewController

@synthesize statusSwitch, usernameTF;

+ (NSMutableDictionary *) read {
	NSLog(@"reading data!\n");
	NSString *error;
	NSString *plistPath;
	NSPropertyListFormat format;
	NSString *rootPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0]; // gets the document directory
	plistPath = [rootPath stringByAppendingPathComponent:@"Deck.plist"];
	if(![[NSFileManager defaultManager] fileExistsAtPath:plistPath]) {
		plistPath = [[NSBundle mainBundle] pathForResource:@"Deck" ofType:@"plist"];
	}
	NSData *plistXML = [[NSFileManager defaultManager] contentsAtPath:plistPath];
	NSDictionary *temp = (NSDictionary *)[NSPropertyListSerialization propertyListFromData: plistXML mutabilityOption:NSPropertyListMutableContainersAndLeaves format:&format errorDescription: &error];
	NSMutableDictionary *myPList = [NSMutableDictionary dictionaryWithDictionary: temp]; 
	[myPList retain];
	return myPList;
}

+ (void) write : (NSDictionary *) myPList{
	NSLog(@"writing data!");

	NSString *error;
	NSString *rootPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
	NSString *plistPath = [rootPath stringByAppendingPathComponent:@"Deck.plist"];

	NSData *plistData = [NSPropertyListSerialization dataFromPropertyList: myPList format:NSPropertyListXMLFormat_v1_0 errorDescription:&error];
	if(plistData) {
		[plistData writeToFile:plistPath atomically:YES];
	}

}

- (void) setUsername {
	[parent setUsername:[usernameTF text]];
	NSMutableDictionary * data = [[NSMutableDictionary alloc] init];
	[data setObject:parent->username forKey:@"name"];
	[parent joinNetwork];
	NSMutableString *str = [[NSMutableString alloc] initWithFormat:@"%d", parent->user_id];
	[data setObject:str forKey:@"id"];
	[HomeViewController write:data]; 
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	parent = (iDeckAppDelegate *) [[UIApplication sharedApplication] delegate];
	self.title = NSLocalizedString(@"iDeck",@"");
	NSMutableDictionary * data = [HomeViewController read];
	NSLog(@"the size of reading is %d\n", [data count]);
	[usernameTF setText: [data objectForKey:@"name"]];
	parent->user_id = [[data objectForKey:@"id"] intValue];
	parent->username = [usernameTF text];
	NSLog(@"you say that the username is %@\n", parent->username);
	[super viewDidLoad];
}

- (BOOL)textFieldShouldReturn:(UITextField *)theTextField {
	[theTextField resignFirstResponder];
	return YES;
}

- (IBAction) editedTextfield:(id)sender {
	[self setUsername];
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
	[super didReceiveMemoryWarning];

	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (IBAction)pushTables:(id)sender {

	if ([parent->username length] > 0) {
		//TablesViewController *tablesViewController = [[TablesViewController alloc] initWithNibName:@"TablesViewController" bundle:[NSBundle mainBundle]];
		[[self navigationController] pushViewController:parent->tablesViewController animated:YES];
		[parent->tablesViewController.listOfTables reloadData];
		//[parent->tablesViewController release];
	} else {
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:nil message:@"Please enter a username!" delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];	
		[alert release];	
	}
}


- (IBAction)pushUsers:(id)sender {
	if ([parent->username length] > 0) {
		FindUsersViewController *findUsersViewController = [[FindUsersViewController alloc] initWithNibName:@"FindUsersViewController" bundle:[NSBundle mainBundle]];
		[[self navigationController] pushViewController:findUsersViewController animated:YES];
		[findUsersViewController release];	
	} else {
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:nil message:@"Please enter a username!" delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];	
		[alert release];	
	}
}

- (IBAction)setStatus:(id)sender {

	if (statusSwitch.on == TRUE) {
		// set to online
		NSLog(@"status is online");
	} else {
		// set to offline
		NSLog(@"status is offline");
	}

}

- (void)dealloc {
	[statusSwitch release];
	[super dealloc];
}


@end
