@class DOMTreeNode;
@class Card;
@class Player;
@class Buttons;
@class iDeckAppDelegate;

#define FACE_UP 0
#define FACE_USERS 1
#define FACE_DOWN 2
#define MOVING 3

@interface Table : UIViewController {
	@public
	DOMTreeNode * root;
    float zoomScale;
	iDeckAppDelegate * parent;
	bool viewTable;
	bool dealState;
  UITextView * text;

}


- (void) viewHand;
- (void) viewTable;

- (void) send :(NSString*) mesg;

- (void) update : (NSURL*) url;
- (void) queryAndViewTable;
- (void) join;
- (void) leave;
- (void) swipe : (int) type;
- (void) dealAction;
- (void) deal;
- (void) shuffle;
- (void) display;
- (Card *) updateCard : (CGPoint) p owner:(int)owner card_id:(int)card_id suit:(NSString *)suit num:(NSString *)number face:(NSString *) face;
- (Player *) updatePlayer : (CGPoint) p owner:(int)owner;
- (void) initializeTable;
- (void) deinitializeTable;


@property(nonatomic) BOOL hswipe;
@property(nonatomic) BOOL vswipe;
@property(nonatomic, readwrite) CGPoint startTouchPosition;
@property(nonatomic, readwrite) CGPoint currentTouchPosition;

@end
