#import "TableSettingsViewController.h"
#import "DOMTreeNode.h"
#import "iDeckAppDelegate.h"
#import "TablesViewController.h"

@implementation TableSettingsViewController

@synthesize tableTypeTF;
@synthesize tableNameTF;
@synthesize numberOfPlayersTF;
@synthesize numberOfDecksTF;
@synthesize numberOfCardsFaceUpTF;
@synthesize cardsPerHandTF;
//@synthesize minimumBet;
@synthesize jokersSwitch;
@synthesize doubleTapMessageTF;
@synthesize horizontalSwipeMessageTF;
@synthesize scrollView;

- (int) modify_table: (int)uid type:(NSString *)type name:(NSString *)name max_players:(int)max_players hand_size:(int)hand_size num_face_up:(int)num_face_up min_bet:(NSString *)min_bet double_tap:(NSString*)double_tap swipe:(NSString*) swipe  {
	
	if (tables) [tables  release];
    XMLParser *parser = [[XMLParser alloc] init];
	NSMutableString * url = [[NSMutableString alloc] init];
	
	
	[url appendFormat: @"http://www.dan-lynch.com/icards.php?action=add_table&user_id=%d&type=%@&name=%@&max_players=%d&hand_size=%d&num_face_up=%d&min_bet=%@&double_tap=%@&swipe=%@",
	 uid, type, name, max_players, hand_size, num_face_up, min_bet, double_tap, swipe];
	NSString* escapedUrl = [url   
							stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]; 
	
	NSLog(@"%@",escapedUrl);
    tables = [parser parseXMLFile:[NSURL URLWithString:escapedUrl]];
	int tid = [node(tables, @"table_id") intValue];
    [tables dump];
    //[tables retain];
    [parser release];
	return tid;
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
 // Custom initialization
 }
 return self;
 }
 */


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	self.title = NSLocalizedString(@"Settings",@"");
	
	scrollView.contentSize = CGSizeMake(320, 600);
	scrollView.maximumZoomScale = 1;
	scrollView.minimumZoomScale = 1;
	scrollView.clipsToBounds = YES;
	scrollView.delegate = self;
	scrollView.zoomScale = 1;
	
	[scrollView flashScrollIndicators];
	
	
	UIBarButtonItem *addButton = [[[UIBarButtonItem alloc]
								   initWithTitle:NSLocalizedString(@"Create Table", @"")
								   style:UIBarButtonItemStyleBordered
								   target:self
								   action:@selector(go)] autorelease];
	self.navigationItem.rightBarButtonItem = addButton;
	
	iDeckAppDelegate * parent = [[UIApplication sharedApplication] delegate];
	
	if ([[parent tableTypeToCreate] isEqualToString:@"Poker"]) {
		tableTypeTF.text = @"Poker";
		numberOfCardsFaceUpTF.text = @"0";
		cardsPerHandTF.text = @"5";
	} else if ([[parent tableTypeToCreate] isEqualToString:@"BlackJack"]) {
		tableTypeTF.text = @"BlackJack";
		numberOfCardsFaceUpTF.text = @"2";
		cardsPerHandTF.text = @"2";
	} else if ([[parent tableTypeToCreate] isEqualToString:@"Big Two"]) {
		tableTypeTF.text = @"Big Two";
		cardsPerHandTF.text = @"13";
		doubleTapMessageTF.text = @"";
		horizontalSwipeMessageTF.text = @"Pass";
	} else {
		tableTypeTF.text = @"";
	}
	
    [super viewDidLoad];
}

- (void) go {
	[self pushGameTable:self];
}

/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[tableTypeTF release];
	[tableNameTF release];
	[numberOfPlayersTF release];
	[numberOfDecksTF release];
	[numberOfCardsFaceUpTF release];
	[cardsPerHandTF release];
	//[minimumBet release];
	[jokersSwitch release];
	[doubleTapMessageTF release];
	[horizontalSwipeMessageTF release];
    [super dealloc];
}


- (BOOL)textFieldShouldReturn:(UITextField *)theTextField {
	[theTextField resignFirstResponder];
	return YES;
}

- (IBAction)showHelpMessage:(id)sender {
	NSString *helpMessage = [NSString stringWithFormat:@"Number of Cards Face Up:\nSet the number of cards to show face up for each player's hand, as in BlackJack.\n\nCards Per Hand:\nUsed for auto-dealing this number of cards per player.\n\nMessages Sent Using Gestures:\nThe gestures can be used to send the messages entered here in the in-game chat box for the dealer and other players."];
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Help" message:helpMessage delegate:self cancelButtonTitle:@"Close" otherButtonTitles:nil];
	[alert show];
	[alert release];
}

- (IBAction)pushGameTable:(id)sender {
	
	if ([tableTypeTF.text length] > 0 && [tableNameTF.text length] > 0 && [numberOfPlayersTF.text length] > 0 && [cardsPerHandTF.text length] > 0 && [numberOfCardsFaceUpTF.text length] > 0) {
		// SOME HARDCODED VALUES
		iDeckAppDelegate * parent = [[UIApplication sharedApplication] delegate];
		int tid = [self modify_table:[parent user_id] type:tableTypeTF.text name:tableNameTF.text max_players:[numberOfPlayersTF.text intValue] hand_size:[cardsPerHandTF.text intValue] num_face_up:[numberOfCardsFaceUpTF.text intValue] min_bet:@"10.00" double_tap:doubleTapMessageTF.text swipe:horizontalSwipeMessageTF.text];
		[parent setTableID:tid];
		[parent startTimer];
		[[parent window] addSubview:[[parent table] view]];
		[parent initializeTable];
		[[self navigationController] popToViewController:parent->tablesViewController animated:YES];
		[parent->tablesViewController.listOfTables reloadData];
		//[[self navigationController] pushViewController:(UIViewController*)[parent table] animated:NO];
		
	} else {
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:nil message:@"Please fill in all fields!" delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];	
		[alert release];	
	}
	
	
}


@end
