#import "TableTypeViewController.h"
#import "iDeckAppDelegate.h"
#import "ContactCell.h"
#import "TableSettingsViewController.h"

@implementation TableTypeViewController

@synthesize tableTypes;


/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
 // Custom initialization
 }
 return self;
 }
 */


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	self.title = NSLocalizedString(@"Table Type",@"");
	tableTypes = [NSArray arrayWithObjects:@"Poker", @"BlackJack", @"Big Two", @"Custom", nil];
	[tableTypes retain];
    [super viewDidLoad];
}


/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {return 1;}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {return 4;}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	
	static NSString *CellIdentifier = @"Cell";
	
	ContactCell *cell = (ContactCell*)[tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (cell == nil) {
		cell = [[[ContactCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
	}
	
	cell.primaryLabel.text = [tableTypes objectAtIndex:indexPath.row];
	
	if(indexPath.row == 0) {
		cell.myImageView.image = [UIImage imageNamed:@"poker-icon.png"];
	}
	else if (indexPath.row == 1) {
		cell.myImageView.image = [UIImage imageNamed:@"blackjack-icon.png"];
	}
	else if (indexPath.row == 2) {
		cell.myImageView.image = [UIImage imageNamed:@"big2-icon.png"];
	}
	else {
		cell.myImageView.image = [UIImage imageNamed:@"backcards-icon.png"];
	}
	
	/*UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	 
	 if (cell == nil) {
	 cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
	 }
	 
	 [cell.textLabel setText:[rows objectAtIndex:indexPath.row]];*/
	
	return cell;
	
}


- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
	return 50;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	iDeckAppDelegate * parent = [[UIApplication sharedApplication] delegate];
	NSLog(@"table type selected is: %@\n",[tableTypes objectAtIndex:indexPath.row]);
	[parent setTableType:[tableTypes objectAtIndex:indexPath.row]];
	TableSettingsViewController *settingsViewController = [[TableSettingsViewController alloc] initWithNibName:@"TableSettingsViewController" bundle:[NSBundle mainBundle]];
	[[self navigationController] pushViewController:settingsViewController animated:YES];
	[settingsViewController release];
}


- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
	return @"Choose a preset or custom table";
}


- (void)dealloc {
	[tableTypes release];
    [super dealloc];
}


@end
