#import "TableView.h"
#import "Player.h"
#import "iDeckAppDelegate.h"
#import "Cards.h"
#import "Table.h"



@implementation TableView
@synthesize startTouchPosition, currentTouchPosition, hswipe, vswipe;

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    UITouch *touch = [touches anyObject];
    // startTouchPosition is an instance variable
	hswipe = FALSE;
	vswipe = FALSE;
    startTouchPosition = [touch locationInView:self];
}

- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
    UITouch *touch = [touches anyObject];
    currentTouchPosition = [touch locationInView:self];
	
	// horizontal swipe detection
    // To be a swipe, direction of touch must be horizontal and long enough.
    if (fabsf(startTouchPosition.x - currentTouchPosition.x) >= HORIZ_SWIPE_DRAG_MIN &&
        fabsf(startTouchPosition.y - currentTouchPosition.y) <= VERT_SWIPE_DRAG_MAX) {
        // It appears to be a swipe.
        if (startTouchPosition.x < currentTouchPosition.x) {
			hswipe = TRUE;
            NSLog(@"swipe right");
			//[self myProcessRightSwipe:touches withEvent:event];
        }
		else if (startTouchPosition.x > currentTouchPosition.x){
			hswipe = TRUE;
			NSLog(@"swipe left");
            //[self myProcessLeftSwipe:touches withEvent:event];
		}
    }
	
	// vertical swipe detection	
	if (fabsf(startTouchPosition.y - currentTouchPosition.y) >= VERT_SWIPE_DRAG_MIN &&
        fabsf(startTouchPosition.x - currentTouchPosition.x) <= HORIZ_SWIPE_DRAG_MAX) {
		if (startTouchPosition.y < currentTouchPosition.y) {
			vswipe = TRUE;
			NSLog(@"swipe down ");
			//[self myProcessRightSwipe:touches withEvent:event];
		}
		else if (startTouchPosition.y > currentTouchPosition.y){
			vswipe = TRUE;
			NSLog(@"swipe up");
			//[self myProcessLeftSwipe:touches withEvent:event];
		}
	}
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
    startTouchPosition.x = 0.0;
	startTouchPosition.y = 0.0;
	
	iDeckAppDelegate * parent = (iDeckAppDelegate*) [[UIApplication sharedApplication] delegate];
	
	if (hswipe) {
		NSLog(@"boolean for horizontal is true");
		// insert function
		[parent->table swipe:0];
	}
	else if (vswipe) {
		NSLog(@"boolean for vertical is true");
		// insert function
		[parent->table swipe:1];
	}
	
}

- (void)touchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event {
    startTouchPosition.x = 0.0;
	startTouchPosition.y = 0.0;
	hswipe = FALSE;
	vswipe = FALSE;
}

- (id)initWithFrame:(CGRect)frame {
	if (self = [super initWithFrame:frame]) {
		
		background = [[UIImageView alloc] initWithFrame:frame];
		[background setImage:[UIImage imageNamed:@"table.png"]];
		[self addSubview:background];
		[self sendSubviewToBack:background];

    
	}
	return self;
}

- (void) sendBack {
	[self sendSubviewToBack:background];	
}

- (void) addBackground {
	[self addSubview:background];
	[self sendSubviewToBack:background];
}

- (void) drawRect : (CGRect) rect {
	for(unsigned int i= 0; i<[[self subviews] count]; i++) {
		if ([[[self subviews] objectAtIndex:i] isKindOfClass:[Card class]]) {
			Card * someCard = [[self subviews] objectAtIndex:i]; 
			[someCard setLoc:[someCard moveTo]];
		}
		if ([[[self subviews] objectAtIndex:i] isKindOfClass:[Player class]]) {
			Player * somePlayer = [[self subviews] objectAtIndex:i]; 
			[somePlayer setLoc:[somePlayer moveTo]];
		}
	}
	[UIView beginAnimations:nil context:nil];
	[UIView setAnimationDuration:1];
}

@end
