#import "TablesViewController.h"
#import "TableSettingsViewController.h"
#import "iDeckAppDelegate.h"
#import "DOMTreeNode.h"
#import "TableCell.h"
#import "TableTypeViewController.h"


@implementation TablesViewController

@synthesize listOfTables;

- (void) getTables {
	
    if (tables) [tables  release];
    XMLParser *parser = [[XMLParser alloc] init];
    NSMutableString * url = [[NSMutableString alloc] init];
	
    [url appendFormat:@"http://dan-lynch.com/icards.php?action=get_tables"];
    tables = [parser parseXMLFile:[NSURL URLWithString:url]];
    [tables retain];
    [parser release];
	
	if (rows) [rows release];
	if (keys) [keys release];
	rows = [[NSMutableArray alloc] init];
	keys = [[NSMutableArray alloc] init];
	unsigned int i = 0;
	for(DOMTreeNode *table in objs(tables, @"tables")) {
		if(is(table, @"table")) {
		    NSString * tableName = [[NSString alloc] initWithFormat:@"%@:%@; %@ players",node(table, @"name"), node(table, @"type"), node(table, @"num_players")];
			NSString * str = [[NSString alloc] initWithString:node(table, @"table_id")];
			[rows addObject:tableName];
			[keys addObject:str];
			[tableName retain];
			[str retain];
		}
		i++;
    }
	
}

- (void)viewDidLoad {
	parent = (iDeckAppDelegate *) [[UIApplication sharedApplication] delegate];
	self.title = NSLocalizedString(@"Tables",@"");
	UIBarButtonItem *newTableButton = [[UIBarButtonItem alloc] initWithTitle:@"New Table" style:UIBarButtonItemStylePlain target:self action:@selector(CreateNewTable)];
	self.navigationItem.rightBarButtonItem = newTableButton;
	
	[self getTables];
    [super viewDidLoad];
}


- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {return 1;}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	[self getTables];
	return [rows count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	[self getTables];
	
	static NSString *CellIdentifier = @"Cell";
	
	TableCell *cell = (TableCell*)[tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (cell == nil) {
		cell = [[[TableCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
	}
	
	NSString *string = [rows objectAtIndex:indexPath.row];
	NSArray *chunks = [string componentsSeparatedByString: @":"];
	cell.primaryLabel.text = [chunks objectAtIndex:0];
	cell.secondaryLabel.text = [chunks objectAtIndex:1];
	
	NSArray *chunks2 = [[chunks objectAtIndex:1] componentsSeparatedByString:@";"];
	NSString *tableType = [chunks2 objectAtIndex:0];
	
	if([[tableType lowercaseString] isEqualToString:@"poker"]) {
		cell.myImageView.image = [UIImage imageNamed:@"poker-icon.png"];
	}
	else if ([[tableType lowercaseString] isEqualToString:@"blackjack"]) {
		cell.myImageView.image = [UIImage imageNamed:@"blackjack-icon.png"];
	}
	else if ([[tableType lowercaseString] isEqualToString:@"big two"]) {
		cell.myImageView.image = [UIImage imageNamed:@"big2-icon.png"];
	}
	else {
		cell.myImageView.image = [UIImage imageNamed:@"backcards-icon.png"];
	}
	
	
	return cell;
	
}


- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
	return 50;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	
	[parent setTableID:[[keys objectAtIndex:indexPath.row] intValue]];
	
	if ([parent table_id] != -1) {		
		[parent startTimer];
		[[parent window] addSubview:[[parent table] view]];
		[parent initializeTable];
	}
	
}


- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
	return @"Select a table to join";
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)viewDidUnload {}

- (void) CreateNewTable {
	TableTypeViewController *typeViewController = [[TableTypeViewController alloc] initWithNibName:@"TableTypeViewController" bundle:[NSBundle mainBundle]];
	[[self navigationController] pushViewController:typeViewController animated:YES];
	[typeViewController release];
}

- (void)dealloc {
	[listOfTables release];
    [super dealloc];
}

@end
