#import "time.h"
@class Table;
@class Hand;
@class TablesViewController;
@interface iDeckAppDelegate : NSObject <UIApplicationDelegate> {
    
    UIWindow *window;
    UINavigationController *navigationController;
	
	@public
	int user_id;
    int table_id;
    bool dealer;
    NSString * username;
	
	Table *table;
    Hand *hand;
	NSMutableDictionary * cards;
		NSString *tableTypeToCreate;
	
    /* for polling */
    time_t now;
    time_t start;
    time_t interval;
	
	NSTimer * timer;
	TablesViewController *tablesViewController;
	
	
}

@property (nonatomic, retain) NSString *username;
@property (nonatomic, retain) NSString *tableTypeToCreate;

- (void) removePlayer:(int)uid;
- (void) freePlayers;


-(void) setTableType : (NSString*)ttype;
- (void) shuffleMe;
- (int) user_id;
- (int) table_id;
-(bool)isDealer;
- (NSString *) getUsername;
-(void) setUsername : (NSString*)uname;
- (void) setUserID:(int)uid;
- (void) setTableID:(int)tid;
- (void) setDealer:(bool)deal;

- (void) checkTime;

- (void) startTimer;
- (void) stopTimer;

- (void) initializeTable;
- (void) leaveTable;
- (void) freeCards;

- (void) joinNetwork;


@property (nonatomic, retain) Table * table;
@property (nonatomic, retain) Hand * hand;
@property (nonatomic, retain) IBOutlet UIWindow *window;
@property (nonatomic, retain) NSMutableDictionary * cards;
@property (nonatomic, retain) IBOutlet UINavigationController *navigationController;
@property (nonatomic, retain) TablesViewController *tablesViewController;

@end

